//3D Printed DIY Button Box by medyk3D
//video here: https://www.youtube.com/watch?v=c75uNtNu9r8
//my blog: medyk3D.com

#include <Joystick.h>
#include <Keypad.h>

//keypad
const byte ROWS = 6; //four rows
const byte COLS = 4; //three columns
char keys[ROWS][COLS] = {
  {'A','B','C','D'},
  {'E','F','G','H'},
  {'I','J','K','L'},
  {'M','N','O','P'},
  {'Q','R','S','T'},
  {'U','V','W','X'},
};
byte rowPins[ROWS] = {9,8,7,6,5,4}; //connect to the row pinouts of the keypad
byte colPins[COLS] = {10,16,14,15}; //connect to the column pinouts of the keypad
Keypad keypad = Keypad(makeKeymap(keys), rowPins, colPins, ROWS, COLS);

// Create the Joystick
Joystick_ Joystick(JOYSTICK_DEFAULT_REPORT_ID,JOYSTICK_TYPE_GAMEPAD,
24, 0, // Button Count, Hat Switch Count
false, false, false, // no X, Y and Z Axis
false, false, false, // No Rx, Ry, or Rz
false, false, // No rudder or throttle
false, false, false); // No accelerator, brake, or steering

void setup() {
  //init serial port
  Serial.begin(115200);
  delay(250);
  //Initialize Joystick Library
  Joystick.begin();
  //add event listener to keypad
  keypad.addEventListener(keypadEvent); //add an event listener for this keypad
}

void loop() {  
  char key = keypad.getKey(); 
}

void keypadEvent(KeypadEvent key){  
  Serial.print(key);
  switch (keypad.getState()){
    case PRESSED:      
      Serial.println(" pressed");
      Joystick.setButton(key-'A',1);    
    break;
    case RELEASED:
      Serial.println(" released");
      Joystick.setButton(key-'A',0);
    break;    
  }
}
